<template>
  <div>
    <v-card>
      <v-card-title>
        <v-btn
          color="primary"
          id="new-instructor-btn"
          @click="instructorCreate = !instructorCreate"
          elevation="0"
        >
          Novo
        </v-btn>

        <v-spacer></v-spacer>

        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          class="shrink"
          single-line
          hide-details
        ></v-text-field>
      </v-card-title>

      <v-container>
        <v-row>
          <div class="col-12">
            <v-data-table
              :headers="headers"
              :items="instructors"
              :items-per-page="5"
              :search="search"
              class="elevation-0"
            >
              <template v-slot:[`item.actions`]="{ item }">
                <v-icon
                  color="primary"
                  title="Editar"
                  @click="openUpdate(item.id)"
                >
                  mdi-pencil
                </v-icon>
                <v-icon
                  class="mx-2"
                  title="Apagar"
                  color="red"
                  @click="deleteInstructor(item.id)"
                >
                  mdi-delete
                </v-icon>
                <v-icon
                  title="Detalhes"
                  color="info"
                  @click="openDetails(item.id)"
                >
                  mdi-eye
                </v-icon>
              </template>
            </v-data-table>
          </div>
        </v-row>
      </v-container>
    </v-card>

    <v-dialog v-model="instructorCreate" max-width="800px">
      <InstructorCreate :closeDialog="() => (instructorCreate = false)" />
    </v-dialog>

    <v-dialog v-model="instructorUpdate" max-width="800px">
      <InstructorEdit
        :closeDialog="closeInstructorUpdate"
        :instructorId="updateInstructorId"
      />
    </v-dialog>

    <v-dialog v-model="instructorDetails" max-width="800px">
      <InstructorDetails
        :closeDialog="closeInstructorDetails"
        :instructorId="detaislInstructorId"
      />
    </v-dialog>
  </div>
</template>

<script>
import InstructorCreate from "../components/InstructorCreate.vue";
import InstructorDetails from "../components/InstructorDetails.vue";
import InstructorEdit from "../components/InstructorEdit.vue";

export default {
  name: "Instructor-view",

  components: {
    InstructorCreate,
    InstructorDetails,
    InstructorEdit,
  },

  created() {
    if (!this.instructors.length) this.$store.dispatch("getInstructors");
  },

  data: () => ({
    search: "",
    instructorCreate: false,
    instructorDetails: false,
    instructorUpdate: false,
    detaislInstructorId: null,
    updateInstructorId: null,
    deleteInstructorId: null,
    headers: [
      { text: "ID", value: "id" },
      { text: "Nome", value: "name" },
      { text: "Email", value: "email" },
      { text: "Ações", value: "actions", sortable: false },
    ],
  }),

  computed: {
    instructors() {
      return this.$store.state.instructor.list;
    },
  },

  methods: {
    editInstructor(instructor) {
      this.updateInstructorId = instructor.id;
      this.instructorCreate = true;
    },
    closeInstructorCreate() {
      this.instructorCreate = false;
    },
    openDetails(id) {
      this.detaislInstructorId = id;
      this.instructorDetails = true;
    },
    openUpdate(id) {
      this.updateInstructorId = id;
      this.instructorUpdate = true;
    },
    closeInstructorDetails() {
      this.instructorDetails = false;
    },
    closeInstructorUpdate() {
      this.instructorUpdate = false;
    },
    async deleteInstructor(id) {
      this.deleteInstructorId = id;
      const reuslt = await this.$swal({
        title: "Tem certeza que quer apagar esse Instrutor?",
        text: "Uma vez que apague não será possivel recuperar",
        icon: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: "Sim, apague!",
        cancelButtonText: "Não, cancelar !",
        closeOnConfirm: false,
        closeOnCancel: false,
      });
      if (reuslt.isConfirmed) {
        this.$store.dispatch("deleteInstructor", this.deleteInstructorId);
        await this.$swal("Apagado com sucesso!", "", "success");
      }
    },
  },
};
</script>
